<?php

//rodicovska trieda pre vsetky Actions

require_once 'config.php';
require_once 'auth.php';
require_once 'lib/template.inc.php';
require_once 'lib/layersmenu.inc.php';

class Action
{
	protected $auth;
	protected $conf;
	protected $txt;

	protected $menuHtml="";
	protected $nadpisHtml="";
	protected $chybaHtml="";
	protected $teloHtml="";

	protected $numScreens = 0;

	protected $defaultNadpis="";


	function Action()
	{
		$this->conf = new Config();

		$this->auth = Auth::factory();

		$this->txt = new Txt();
		$this->txt->setLang($_SESSION['lang']);
	}

	public function showPage()
	{
		$this->fillMenu();

		if($this->defaultNadpis != "")
		{
			$this->nadpisHtml = $this->defaultNadpis;
		}
	
		$tpl = new HTML_Template_Sigma($this->conf->getPath('templates_dir'));
		$tpl->loadTemplateFile('main.tpl.html');
		
		if($this->chybaHtml!="")
		{
				
			$chyba = $this->txt->getText('actionerrorlabel') . ': ' . $this->chybaHtml;
			$tpl->setVariable(array('chyba'=>$chyba));
			$tpl->parse('chyba_row');
		}
		
		if($this->nadpisHtml!="")
		{
			$tpl->setVariable(array('nadpis'=>$this->nadpisHtml));
			$do = DB_DataObject::factory('HELP');
			$do->hlpcode = get_class($this);
			if($do->find() > 0)
			{
				$tpl->setVariable(array('linky'=> '<a href="index.php?ACTION=HelpAction&SCREEN=1&HLP=' . get_class($this) . '" target="sajk">' . $this->txt->getText('helplabel') .  '</a>' ));
			}
			$tpl->parse('nadpis_row');
		}
	
		$tpl->setVariable(array('menu'=>$this->menuHtml,'telo'=>$this->teloHtml));
		$tpl->show();
		
	}

	private function fillMenu()
	{

		$do = DB_DataObject::factory('MENU');
		$do->layer=0;
		$do->orderBy('vieworder');
		$do->find();

		$menu="";
		while($do->fetch())
		{
			if($do->link)
			{
				$link = "index.php?" . $do->link;
			}
			else
			{
				$link = "";
			}
			$menu .= ".|" . $this->txt->getText($do->textcode) . "|" . $link . "|||\n";

			$do2 = DB_DataObject::factory('MENU');
			$do2->layer=1;
			$do2->parent = $do->id;
			$do2->orderBy('vieworder');
			$do2->find();
			
			while($do2->fetch())
			{
				if($do2->link)
				{
					$link = "index.php?" . $do2->link;
				}
				else
				{
					$link = "";
				}
				$menu .= "..|" . $this->txt->getText($do2->textcode) . "|" . $link . "|||\n";
			}
			$do2->free();
			unset($do2);
		}

	
		$mid = new LayersMenu();

		$mid->setDirroot(APP_PATH . "/phplayersmenu");
		$mid->setLibdir("lib/");
		$mid->setLibjsdir("libjs/");
		$mid->setLibjswww("phplayersmenu/libjs/");
		$mid->setImgdir("images/");
		$mid->setImgwww("phplayersmenu/pictures/");
		
		$mid->setMenuStructureString($menu);
		$mid->parseStructureForMenu("menu");
		$mid->newTreeMenu("menu");
		$this->menuHtml = $mid->getTreeMenu("menu");
	}

	public function getNumScreens()
	{
		return $this->numScreens;
	}
}

?>
