<?php

/*Autentizacna a autorizacna trieda*/
define('FIRST_PAGE','1');
define('WRONG_DATA','2');
define('WRONG_NAME_PW','3');

require_once 'txt.php';
require_once 'config.php';

class Auth
{

	var $uid;
	
	function Auth()
	{
	}

	function factory()
	{
		session_start();

		if($_GET['logout']==1)
		{
			session_destroy();
			Auth::showLoginPage(FIRST_PAGE);
		}

		if($_SESSION['auth']) 
		{
			return $_SESSION['auth'];
		}
		
		if(!$_POST['meno'] && !$_POST['heslo'])
		{
			session_destroy();
			Auth::showLoginPage(FIRST_PAGE);
		}

		if(!$_POST['meno'] || !$_POST['heslo'])
		{
			session_destroy();
			Auth::showLoginPage(WRONG_DATA);
		}

		if(Auth::check($_POST['meno'],$_POST['heslo']))
		{
			$auth_object = new Auth();
			$_SESSION['auth'] = $auth_object;
			$_SESSION['lang'] = $_POST['jazyk'];
			return $auth_object;
		}
		else
		{
			session_destroy();
			Auth::showLoginPage(WRONG_NAME_PW);
		}

	}


	/******************************************/
	//skotroluje meno a heslo pouzivatela
	function check($name,$pw)
	{
		$user = DB_DataObject::factory('USER');
		$user->username = $name;
		$n = $user->find();
		if($n == 0)
			return 0;

		$user->fetch();
		if($user->pw == md5($pw))
			return 1;

		return 0;
	}

	/*****************************************/
	//zobrazi prihlasovaciu stranku pre pouzivatela s prislusnou spravou
	function showLoginPage($type)
	{
		$conf = new Config();
		$txt = new Txt();
	
		$tpl = new HTML_Template_Sigma($conf->getPath('templates_dir'));
		$tpl->loadTemplateFile('login.tpl.html');

		if($_POST['jazyk'])
		{
			$txt->setLang($_POST['jazyk']);
			$actuallang=$_POST['jazyk'];
		}
		else
		{
			$txt->setLang($conf->getDefaultLang());
			$actuallang=$conf->getDefaultLang();
		}

		switch($type) {
			case WRONG_DATA:
				$tpl->setVariable(array('sprava' => $txt->getText('login1') ));
				$tpl->parse('login');
				break;
			case WRONG_NAME_PW:
				$tpl->setVariable(array('sprava' => $txt->getText('login2') ));
				$tpl->parse('login');
				break;
			case FIRST_PAGE:
			default:
				break;
		}
		
		$langcodes = $txt->getLanguages();
		foreach($langcodes as $code)
		{
			$tpl->setVariable(array('langcode' => $code));
			if($actuallang == $code) 
			{
				$tpl->setVariable(array('sel' => 'selected'));
			}
			$tpl->parse('lang');
		}
		
		$tpl->setVariable( array(  'name_label' => $txt->getText('loginnamelabel'),
									'pw_label' => $txt->getText('loginpwlabel'),
									'lang_label' => $txt->getText('loginlanglabel'),
									'submit_label' => $txt->getText('loginsubmitlabel') ));
									
		$tpl->parse('form');
		
		$tpl->show();

		exit();
	}
	
}

?>
